<!DOCTYPE html>
<html>
    <head>
        <meta charset="UTF-8">
        <title>{% block title %}Welcome!{% endblock %}</title>
        {% block stylesheets %}{% endblock %}
    </head>
    <body>
        {% block body %}
            <div id="player"></div>
            <div id="logs"></div>
        {% endblock %}
        {% block javascripts %}{% endblock %}
        <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
        <script>

            var tag = document.createElement('script');
            tag.src = "https://www.youtube.com/iframe_api";
        
            var firstScriptTag = document.getElementsByTagName('script')[0];
            firstScriptTag.parentNode.insertBefore(tag, firstScriptTag);

            var player;
            function onYouTubeIframeAPIReady() {
                player = new YT.Player('player', {
                    height: '360',
                    width: '640',
                    videoId: '{{ videoID }}',
                    events: {
                        'onReady': onPlayerReady,
                        'onStateChange': onStateChange,
                    }
                });
            }

            function onPlayerReady(event) {
                event.target.playVideo();
            }
            
            function onStateChange(state, data) {
                var url = getUrl(state);
                $.post(url, {
                    'time': state.target.getCurrentTime(),
                } );
            }
            
            var videoID = "{{ videoID }}";
            const eventSource = new EventSource('{{ MERCURE_SERVER_URL }}?topic=' + encodeURIComponent('/'+videoID));
            
            eventSource.onmessage = event => {
                var data = JSON.parse(event.data);
                if(data.action == 'pause') {
                    player.pauseVideo();
                }

                if(data.action == 'play') {
                    player.playVideo();
                }
                if(data.action == "sync") {
                    var url = getUrl('sync');
                    $.post(url, {
                        'time': state.target.getCurrentTime(),
                    } );
                }
                if(data.data.time !== null) {
                    if(parseInt(player.getCurrentTime()) != parseInt(data.data.time)) {
                        console.log('seeking from '+player.getCurrentTime()+'to '+data.data.time);
                        console.log(data.action);
                        player.seekTo(data.data.time);
                    }
                }
            }


            function getUrl(state) {
                switch(state.data) {
                    case YT.PlayerState.PLAYING:
                        return "{{ path('youtube_play', {'videoID': videoID}) }}";
                        break;
                    case YT.PlayerState.PAUSED:
                        return "{{ path('youtube_pause', {'videoID': videoID}) }}";
                        break;
                    case 'sync': 
                        return "{{ path('youtube_sync', {'videoID': videoID}) }}";
                        break;
                }
            }
            

        </script>
    </body>
</html>
